#!/usr/bin/env node
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _chalk = require("chalk");

var _webpack = _interopRequireDefault(require("webpack"));

var _commander = _interopRequireDefault(require("commander"));

var _validateSchema = _interopRequireDefault(require("../lib/validate-schema"));

require("../bootstrap");

var _ = require("..");

(0, _validateSchema.default)();

_commander.default.parse(process.argv);

const appConfig = (0, _.pRequire)('config/packing');
const webpackConfig = (0, _.pRequire)('config/webpack.build.babel', {}, appConfig);
(0, _webpack.default)(webpackConfig, (err, stats) => {
  if (err) {
    console.log(err);
  } else if (stats.hasErrors()) {
    let plainError = '';
    stats.toJson().errors.forEach(error => {
      Object.keys(error).forEach(key => {
        plainError += `\n${(0, _chalk.yellow)(key)}: ${(0, _chalk.red)(error[key])}`;
      });
      plainError += '\n';
    });
    const message = (0, _chalk.red)('[build]: 💔 Webpack 打包失败。\n') + plainError;
    console.log(message); // 让 jenkins 终止编译

    process.exit(1);
  } else {
    console.log(stats.toString(stats));
    console.log('[build]:💚 Webpack 打包成功。'); // jenkins 编译完不退出，这里临时处理一下，需要定位具体原因

    process.exit(0);
  }
});