"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _path = require("path");

var _webpack = _interopRequireDefault(require("webpack"));

var _cleanWebpackPlugin = require("clean-webpack-plugin");

require("../bootstrap");

var _ = require("..");

var _webpackServe = _interopRequireDefault(require("./webpack.serve.loader"));

/**
 * webpack开发环境配置文件
 * @author Joe Zhong <zhong.zhi@163.com>
 * @module config/webpack.dll.babel
 */

/**
 * 生成webpack配置文件
 * @param {object} program 程序进程，可以获取启动参数
 * @return {object}
 */
var _default = () => {
  const context = (0, _.getContext)();
  const {
    commonChunks,
    path: {
      tmpDll
    }
  } = (0, _.pRequire)('config/packing');
  const output = {
    filename: '[name].js',
    path: (0, _path.resolve)(context, tmpDll),
    library: '[name]_[hash]'
  };
  const plugins = [// new CleanWebpackPlugin(tmpDll, {
  //   root: context,
  //   verbose: false
  // }),
  new _cleanWebpackPlugin.CleanWebpackPlugin({
    cleanOnceBeforeBuildPatterns: [tmpDll]
  }), new _webpack.default.DllPlugin({
    name: '[name]_[hash]',
    path: (0, _path.resolve)(context, `${tmpDll}/[name]-manifest.json`)
  })];
  return {
    mode: 'development',
    context,
    entry: commonChunks,
    output,
    module: _webpackServe.default,
    plugins
  };
};

exports.default = _default;
module.exports = exports.default;