"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _path = require("path");

var _apolloServerExpress = require("apollo-server-express");

var _graphqlTools = require("graphql-tools");

var _mergeGraphqlSchemas = require("merge-graphql-schemas");

var _bodyParser = _interopRequireDefault(require("body-parser"));

var _default = (app, options) => {
  const {
    graphqlEndpoint,
    graphiqlEndpoint
  } = options;

  try {
    let typesArray = '';
    let mocks = {};

    try {
      typesArray = (0, _mergeGraphqlSchemas.fileLoader)((0, _path.resolve)('mock/**/schema.js'));
      mocks = (0, _mergeGraphqlSchemas.mergeResolvers)((0, _mergeGraphqlSchemas.fileLoader)((0, _path.resolve)('mock/**/resolver.js')));
    } catch (e) {
      console.log(e);
    }

    try {
      const schema = (0, _graphqlTools.makeExecutableSchema)({
        typeDefs: (0, _mergeGraphqlSchemas.mergeTypes)(typesArray)
      });
      (0, _graphqlTools.addMockFunctionsToSchema)({
        schema,
        mocks
      });
      app.use(graphqlEndpoint, _bodyParser.default.json(), (0, _apolloServerExpress.graphqlExpress)(() => ({
        schema
      })));
      app.use(graphiqlEndpoint, (0, _apolloServerExpress.graphiqlExpress)({
        endpointURL: graphqlEndpoint,
        query: ''
      }));
    } catch (e) {
      console.log(e);
    }
  } catch (e) {
    console.log('\n缺少依赖包，请先安装 npm i --dev apollo-server-express graphql-tools merge-graphql-schemas body-parser \n');
    process.exit(1);
  }
};

exports.default = _default;
module.exports = exports.default;