"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _path = require("path");

var _fs = require("fs");

var _util = require("util");

var _importFresh = _interopRequireDefault(require("import-fresh"));

var _ = require("..");

/* eslint import/no-dynamic-require: 0 */

/* eslint global-require: 0 */
var _default = (file, program, appConfig) => {
  const context = (0, _.getContext)();
  let configFile = file;

  if (['.js', '.json'].indexOf((0, _path.extname)(file)) < 0) {
    configFile += '.js';
  } // 为了测试方便，增加 `process.env.CONTEXT`


  const pathInProject = (0, _path.resolve)(context ? (0, _path.join)(context, configFile) : configFile);
  const pathInLib = (0, _path.resolve)(__dirname, '..', configFile); // 此处不能使用 require.cache
  // 因为该方法依赖 process.env.CONTEXT
  // 而在跑测试用例时会在不同的用例设置不同的 process.env.CONTEXT
  // 使用 require.cache 就会导致除第一次外的所有结果都从缓存中加载，从而引发错误

  let defaultConfig = (0, _importFresh.default)(pathInLib);
  defaultConfig = defaultConfig.default || defaultConfig;

  if ((0, _util.isFunction)(defaultConfig)) {
    defaultConfig = defaultConfig(program, appConfig);
  }

  if ((0, _fs.existsSync)(pathInProject)) {
    let projectConfig = require(pathInProject);

    projectConfig = projectConfig.default || projectConfig;
    return (0, _util.isFunction)(projectConfig) ? projectConfig(defaultConfig, program, appConfig) : projectConfig;
  }

  return defaultConfig;
};

exports.default = _default;
module.exports = exports.default;